using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using SimpleJSON;
using System;


namespace JayJayWon
{
    public static class OrdnanceDepot
    {
//        private const int minOrdnanceTypeStockLevel =1;
        public static void Init()
        {
            checkedInOrdnanceByType = new Dictionary<string, HashSet<Ordnance>>();
            checkedOutOrdnanceByType = new Dictionary<string, HashSet<Ordnance>>();
            ordnanceTypeResupplyRequested = new Dictionary<string, int>();
            InitOrdnance("A");
            InitOrdnance("B");
            InitOrdnance("C");
        }

        private static void InitOrdnance(string ordnanceType)
        {
            HashSet<Ordnance> ordnanceCollection1 = new HashSet<Ordnance>();
            checkedInOrdnanceByType.Add(ordnanceType, ordnanceCollection1);
            for (int i = 1; i < 10; i++)
            {
                string latestVAR = SuperController.singleton.NormalizeLoadPath("JayJayWon.CumAssist.latest:/Custom/Clothing/Male/JayJayWon/Cum String/Cum String " + ordnanceType + i.ToString()+"/Cum String " + ordnanceType + i.ToString()+".vam");

                string latestVARTexture = SuperController.singleton.NormalizeLoadPath("JayJayWon.CumAssist.latest:/Custom/Clothing/Male/JayJayWon/Cum String/Cum String Textures/CC_1_D.jpg");
                latestVARTexture = latestVARTexture.Remove(latestVARTexture.Length - 7);

                Ordnance newOrdnance = new Ordnance(ordnanceType, "clothing:" + latestVAR,"JayJayWon:Cum String " + ordnanceType + i.ToString()+"Sim", "JayJayWon:Cum String " + ordnanceType + i.ToString() + "MaterialCombined", latestVARTexture);

                ordnanceCollection1.Add(newOrdnance);
            }
            HashSet<Ordnance> ordnanceCollection2 = new HashSet<Ordnance>();
            checkedOutOrdnanceByType.Add(ordnanceType, ordnanceCollection2);
            ordnanceTypeResupplyRequested.Add(ordnanceType, 0);
        }

        public static Salvo CheckOutSalvo()
        {
            List<Ordnance> payLoad = new List<Ordnance>();

            if (checkedInOrdnanceByType["A"].Count == 0) FireControl.RequestImmediateOrdnanceReturn("A");
            if (checkedInOrdnanceByType["B"].Count == 0) FireControl.RequestImmediateOrdnanceReturn("B");
            if (checkedInOrdnanceByType["C"].Count == 0) FireControl.RequestImmediateOrdnanceReturn("C");

            Ordnance ordA = checkedInOrdnanceByType["A"].First<Ordnance>();
            Ordnance ordB = checkedInOrdnanceByType["B"].First<Ordnance>();
            Ordnance ordC = checkedInOrdnanceByType["C"].First<Ordnance>();

            payLoad.Add(ordA);
            payLoad.Add(ordB);
            payLoad.Add(ordC);

            System.Random rnd = new System.Random();
            int salvoSizeAdjust = rnd.Next(3);

            while (salvoSizeAdjust > 0)
            {
                int ordnacePosToRemove = UnityEngine.Random.Range(0, payLoad.Count);
                payLoad.RemoveAt(ordnacePosToRemove);
                salvoSizeAdjust--;
            }

            foreach(Ordnance ord in payLoad)
            {
                CheckOutOrdnance(ord);
            }

            Salvo salvo = new Salvo(payLoad);

            return (salvo);
        }

        private static void CheckOutOrdnance(Ordnance ord)
        {
            checkedInOrdnanceByType[ord.GetOrdnanceType()].Remove(ord);
            checkedOutOrdnanceByType[ord.GetOrdnanceType()].Add(ord);
        }

        public static void InventoryLevelCheck()
        {
            int minOrdnanceTypeStockLevel = (int) (9f - Globals.cumAssist.maxCumIntensityJSF.val);
            foreach (string ordnanceType in checkedInOrdnanceByType.Keys.ToList())
            {
                int stockLevel = checkedInOrdnanceByType[ordnanceType].Count;
                if (stockLevel< minOrdnanceTypeStockLevel && ordnanceTypeResupplyRequested[ordnanceType]< minOrdnanceTypeStockLevel)
                {
                    int stockRequestQuantity = minOrdnanceTypeStockLevel - stockLevel;

                    FireControl.RequestOrdnanceReturn(ordnanceType, stockRequestQuantity);
                    ordnanceTypeResupplyRequested[ordnanceType] += stockRequestQuantity;

                }
            }

        }

        public static void ReturnOrdnance(string ordnanceType, List<Ordnance> ordnanceList)
        {
            foreach (Ordnance ordnance in ordnanceList)
            {
                checkedInOrdnanceByType[ordnanceType].Add(ordnance);
                checkedOutOrdnanceByType[ordnanceType].Remove(ordnance);
                
            }
            ordnanceTypeResupplyRequested[ordnanceType] -= ordnanceList.Count;
            
        }

        private static Dictionary<string, HashSet<Ordnance>> checkedInOrdnanceByType;
        private static Dictionary<string, HashSet<Ordnance>> checkedOutOrdnanceByType;
        private static Dictionary<string, int> ordnanceTypeResupplyRequested;
    }

    public class Ordnance
    {
        private JSONStorableBool clothingItemEnabledJSB;
        private JSONStorable clothingItemSimJSS;
        private JSONStorable clothingItemMaterialJSS;

        private string ordnanceType;

        private bool loaded = false;

        private string clothingItemEnabledJSONName;
        private string clothingItemSimJSONName;
        private string clothingItemMaterialJSONName;

        public bool IsLoaded() { return loaded; }
        public void SetUnloaded() { loaded = false; }

        public string GetOrdnanceType() { return ordnanceType; }
        public Ordnance(string _ordnanceType, string _clothingItemEnabledJSONName, string _clothingItemSimJSONName, string _clothingItemMaterialJSONName, string latestVARTexture)
        {
            clothingItemEnabledJSONName = _clothingItemEnabledJSONName;
            clothingItemSimJSONName = _clothingItemSimJSONName;
            clothingItemMaterialJSONName = _clothingItemMaterialJSONName;

            ordnanceType = _ordnanceType;

            JSONStorable geometry = Globals.MVRS.containingAtom.GetStorableByID("geometry");
            clothingItemEnabledJSB = geometry.GetBoolJSONParam(clothingItemEnabledJSONName);

            if (clothingItemEnabledJSB != null) Globals.MVRS.StartCoroutine(DelayedTextureSetting(latestVARTexture));
            else Utils.LogDebug("<Ordnance Constructor> " + _clothingItemEnabledJSONName + " cant be found in geometry storable.");    
        }

        private IEnumerator DelayedTextureSetting(string latestVARTexture)
        {
            clothingItemEnabledJSB.val = true;
            while (clothingItemSimJSS == null || clothingItemMaterialJSS == null)
            {
                yield return new WaitForEndOfFrame();
                clothingItemSimJSS = Globals.MVRS.containingAtom.GetStorableByID(clothingItemSimJSONName);
                clothingItemMaterialJSS = Globals.MVRS.containingAtom.GetStorableByID(clothingItemMaterialJSONName);
            }

            int i = UnityEngine.Random.Range(1, 15);

            JSONStorableUrl mainTexJSU = clothingItemMaterialJSS.GetUrlJSONParam("customTexture_MainTex");
            mainTexJSU.val = latestVARTexture + i.ToString()+"_D.jpg";
//            mainTexJSU.val = "";

            JSONStorableUrl glossTexJSU = clothingItemMaterialJSS.GetUrlJSONParam("customTexture_GlossTex");
           glossTexJSU.val = latestVARTexture + i.ToString() + "_S.jpg";
 //           glossTexJSU.val = "";

            JSONStorableUrl alphaTexJSU = clothingItemMaterialJSS.GetUrlJSONParam("customTexture_AlphaTex");
            alphaTexJSU.val = latestVARTexture + i.ToString() + "_A.jpg";
 //          alphaTexJSU.val = "";

            JSONStorableUrl bumpTexJSU = clothingItemMaterialJSS.GetUrlJSONParam("customTexture_BumpMap");
            bumpTexJSU.val = latestVARTexture + i.ToString() + "_N.png";
 //          bumpTexJSU.val = "";

            clothingItemEnabledJSB.val = false;
        }

        public void SetPreLaunchAppearance()
        {
            clothingItemEnabledJSB.val = true;
            loaded = false;
            clothingItemSimJSS = Globals.MVRS.containingAtom.GetStorableByID(clothingItemSimJSONName);
            clothingItemMaterialJSS = Globals.MVRS.containingAtom.GetStorableByID(clothingItemMaterialJSONName);
            Globals.MVRS.StartCoroutine(DelayedPreLaunchClothAppearance());
            
        }

        public void SetImpactAppearance()
        {
            Globals.MVRS.StartCoroutine(DelayedImpactClothAppearance());
        }

        private IEnumerator DelayedImpactClothAppearance()
        {
            yield return new WaitForSeconds(0.15f);

            ClothSettingCollection.SetImpactSettings(ordnanceType, clothingItemSimJSS, clothingItemMaterialJSS);
        }
        private IEnumerator DelayedPreLaunchClothAppearance()
        {
            while (clothingItemSimJSS == null || clothingItemMaterialJSS == null)
            {
                yield return new WaitForEndOfFrame();
                clothingItemSimJSS = Globals.MVRS.containingAtom.GetStorableByID(clothingItemSimJSONName);
                clothingItemMaterialJSS = Globals.MVRS.containingAtom.GetStorableByID(clothingItemMaterialJSONName);
            }
            SetCollision(true);
            ClothSettingCollection.SetChamberLoadSettings(ordnanceType, clothingItemSimJSS, clothingItemMaterialJSS);

            Transform clothingGeometryTransform = Globals.MVRS.containingAtom.gameObject.transform.Find("rescale2/geometry/MaleClothes/CustomClothingItem/" + clothingItemSimJSS.name);
            ClothSimControl csc = clothingGeometryTransform.GetComponent<ClothSimControl>();

            while (csc.IsSimulationResetting())
            {
                yield return new WaitForFixedUpdate();
            }

            yield return new WaitForSeconds(0.5f);
            loaded = true;
        }

        public void SetCollision(bool collisionOn)
        {
            JSONStorableBool collisionEnabledJSB = clothingItemSimJSS.GetBoolJSONParam("collisionEnabled");
            JSONStorableBool simEnabledJSB = clothingItemSimJSS.GetBoolJSONParam("simEnabled");
            simEnabledJSB.val = true;
            collisionEnabledJSB.val = collisionOn;
        }

        public void SetLaunchAppearance()
        {
            ClothSettingCollection.SetEjacSettings(ordnanceType, clothingItemSimJSS, clothingItemMaterialJSS);            
        }

        public void SetAlpha(float level)
        {
            ClothSettingCollection.SetAlpha(ordnanceType, clothingItemMaterialJSS, level);
        }

        public void TurnOff()
        {
            clothingItemEnabledJSB.val = false;
        }

    }

    public class Salvo
    {
        public Salvo (List<Ordnance> _payLoad)
        {
            payload = _payLoad;
            launched = false;
        }
        public bool IsLoaded()
        {
            bool loaded = true;
            foreach (Ordnance round in payload)
            {
                if (!round.IsLoaded()) loaded = false;
            }
            return (loaded);
        }
        public void ChamberLoad()
        {
            foreach (Ordnance round in payload)
            {
                round.SetPreLaunchAppearance();
            }
        }

        public void SetLaunched(List<Ordnance> firedOrdnaceManifest)
        {
            foreach (Ordnance round in payload)
            {
                launched = true;
                round.SetLaunchAppearance();
                firedOrdnaceManifest.Add(round);
            }
        }

        public void SetUnloaded()
        {
            foreach (Ordnance round in payload)
            {
                round.SetUnloaded();
                round.SetImpactAppearance();
            }
        }

        public bool IsLaunched() { return launched; }

        private bool launched;
        private List<Ordnance> payload;
    }
}