using System;
using UnityEngine;
using MVR.FileManagementSecure;
using SimpleJSON;

namespace JayJayWon
{

    public class CumAssist : MVRScript
    {
        const string pluginName = "CumAssist";
        const string pluginAuthor = "JayJayWon";
        const string pluginVersion = "1.3";
        public override void Init()
        {
            try
            {
                minFireIntervalJSF = new JSONStorableFloat("Min fire interval (seconds)", 2f, MinFireIntervalUpdated, 0f, 10f, false);
                maxFireIntervalJSF = new JSONStorableFloat("Max fire interval (seconds)", 4f, MaxFireIntervalUpdated, 0f, 10f, false);
                RegisterFloat(minFireIntervalJSF);
                RegisterFloat(maxFireIntervalJSF);

                autoFireContinuousJSB = new JSONStorableBool("Continuous Auto Fire", true, ContinuousAutoFireEnabled);
                RegisterBool(autoFireContinuousJSB);
                autoFireShotsJSF = new JSONStorableFloat("Number of shots", 3f, AutoFireShotsUpdated, 0f, 20f);
                RegisterFloat(autoFireShotsJSF);

                maxCumIntensityJSF = new JSONStorableFloat("Maximum cum intensity", 4f, MaxCumIntensityUpdated, 1f, 8f, true);
                RegisterFloat(maxCumIntensityJSF);

                cumStringGPUIterationsJSF = new JSONStorableFloat("CumString: GPU Iterations", 2f, GPUIterationsUpdated, 1f, 7f, true);
                RegisterFloat(cumStringGPUIterationsJSF);

                cumStringCollisionDistanceJSF = new JSONStorableFloat("CumString: Collision Radius", 0.005f, 0.001f, 0.1f, true);
                RegisterFloat(cumStringCollisionDistanceJSF);

                minCumStickinessJSF = new JSONStorableFloat("Minimum Cum Stickiness", 5f, MinCumStickinessUpdated, 1f, 9f);
                RegisterFloat(minCumStickinessJSF);
                maxCumStickinessJSF = new JSONStorableFloat("Maximum Cum Stickiness", 8f, MaxCumStickinessUpdated, 1f, 9f);
                RegisterFloat(maxCumStickinessJSF);

                enableCockTwitchJSB = new JSONStorableBool("Enable cock twitch", true);
                RegisterBool(enableCockTwitchJSB);

            }
            catch (Exception e)
            {
                SuperController.LogError($"{nameof(CumAssist)}.{nameof(Init)}: {e}");
            }
            
        }

        

        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            JSONClass saveJSON = base.GetJSON(includePhysical, includeAppearance, true);
            saveJSON["isMale"].AsBool = isMale;
            return (saveJSON);
        }

        public override void RestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, JSONArray presetAtoms = null, bool setMissingToDefault = true)
        {
            base.RestoreFromJSON(jc, restorePhysical, restoreAppearance, presetAtoms, setMissingToDefault);
            if (jc["isMale"] !=null) isMale = jc["isMale"].AsBool;
        }

        private bool IsMale(Atom atom)
        {
            bool isMale = false;
            
            // If the peson atom is not "On", then we cant determine their gender it seems as GetComponentInChildren<DAZCharacter> just returns null
            if (atom.on) isMale = atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("male") ||
                    atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("jarlee") ||
                    atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("jarjulian") ||
                    atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("Futa");

            return (isMale);
        }

        private void AutoFireUpdated(bool val)
        {
            UpdateAutoFireSliders();
        }
        private void ContinuousAutoFireEnabled(bool val)
        {           
            if (!val) remainingAutoFireShots = (int) autoFireShotsJSF.val;
            UpdateAutoFireSliders();
        }


        private void MinCumStickinessUpdated(float val)
        {
            if (val < 1f) minCumStickinessJSF.valNoCallback = 1f;
            if (minCumStickinessJSF.val > maxCumStickinessJSF.val) maxCumStickinessJSF.valNoCallback = minCumStickinessJSF.val;
        }
        private void MaxCumStickinessUpdated(float val)
        {
            if (val < 1f) maxCumStickinessJSF.valNoCallback = 1f;
            if (maxCumStickinessJSF.val < minCumStickinessJSF.val) minCumStickinessJSF.valNoCallback = maxCumStickinessJSF.val;
        }
        private void AutoFireShotsUpdated(float val)
        {
            autoFireShotsJSF.valNoCallback = Mathf.RoundToInt(autoFireShotsJSF.val);
            if (autoFireShotsJSF.val < remainingAutoFireShots) remainingAutoFireShots = (int) autoFireShotsJSF.val;
            SetAutoFireCountButtonLabel();

        }
        private void MinFireIntervalUpdated(float val)
        {
            if (val < 0f) minFireIntervalJSF.valNoCallback = 0f;
            if (minFireIntervalJSF.val > maxFireIntervalJSF.val) maxFireIntervalJSF.valNoCallback = minFireIntervalJSF.val;
        }
        private void MaxFireIntervalUpdated(float val)
        {
            if (val < 0f) maxFireIntervalJSF.valNoCallback = 0f;
            if (maxFireIntervalJSF.val < minFireIntervalJSF.val) minFireIntervalJSF.valNoCallback = maxFireIntervalJSF.val;
        }
        public void UpdateAutoFireSliders()
        {
            if (minFireIntervalSlider != null) RemoveSlider(minFireIntervalSlider);
            if (maxFireIntervalSlider != null) RemoveSlider(maxFireIntervalSlider);
            if (autoFireContinuousToggle != null) RemoveToggle(autoFireContinuousToggle);
            if (autoFireShotsSlider != null) RemoveSlider(autoFireShotsSlider);
            if (autoFireShotsReset != null) RemoveButton(autoFireShotsReset);

            if (autoFireEnabledJSB.val)
            {
                minFireIntervalSlider = CreateSlider(minFireIntervalJSF);
                maxFireIntervalSlider = CreateSlider(maxFireIntervalJSF);
                autoFireContinuousToggle = CreateToggle(autoFireContinuousJSB);
                if (!autoFireContinuousJSB.val)
                {
                    autoFireShotsSlider = CreateSlider(autoFireShotsJSF);
                    autoFireShotsSlider.valueFormat = "F0";
                    autoFireShotsSlider.quickButtonsEnabled = false;

                    autoFireShotsReset = CreateButton("Reset Remaining Shots (" + remainingAutoFireShots.ToString() + ")");
                    autoFireShotsReset.button.onClick.AddListener(() => { remainingAutoFireShots = Mathf.RoundToInt( autoFireShotsJSF.val); SetAutoFireCountButtonLabel(); });
                }
            }
        }

        public void SetAutoFireCountButtonLabel()
        {
            if (autoFireShotsReset!=null) autoFireShotsReset.label = "Reset Remaining Shots (" + remainingAutoFireShots.ToString() + ")";
        }
        private void GPUIterationsUpdated(float val)
        {
            cumStringGPUIterationsJSF.valNoCallback = Mathf.RoundToInt(val);
        }
        private void MaxCumIntensityUpdated(float val)
        {
            maxCumIntensityJSF.valNoCallback = Mathf.RoundToInt(val);
        }
        private void AtomNameUpdate(string oldName, string newName)
        {
            FireControl.AtomNameUpdate(oldName, newName);
        }

        private void AtomRemovedUpdate(Atom atom)
        {
            FireControl.AtomRemovedUpdate(atom);
        }
        void Start()
        {
            if (!isMale) isMale = (containingAtom.type == "Person" && IsMale(containingAtom));
            if (isMale)
            {
                isActive = true;
                Globals.MVRS = this;
                Globals.containingAtom = containingAtom;
                Globals.cumAssist = this;

                remainingAutoFireShots = (int) autoFireShotsJSF.val;

                ClothSettingCollection.Init();
                OrdnanceDepot.Init();
                FireControl.Init();               

                fireButton = CreateButton("Fire");
                fireButton.button.onClick.AddListener(() => { FireControl.FireSalvo(); });

                clearButton = CreateButton("Clear");
                clearButton.button.onClick.AddListener(() => { FireControl.ClearAllOrdnance(); });

                autoFireEnabledJSB = new JSONStorableBool("Auto Fire", false, AutoFireUpdated);
                UIDynamicToggle toggle = CreateToggle(autoFireEnabledJSB);
                RegisterBool(autoFireEnabledJSB);

                JSONStorableAction fireJSA = new JSONStorableAction("fire", () => { FireControl.FireSalvo(); });
                JSONStorableAction clearJSA = new JSONStorableAction("clear", () => { FireControl.ClearAllOrdnance(); });
                JSONStorableAction resetJSA = new JSONStorableAction("reset auto fire shots", () => { remainingAutoFireShots = Mathf.RoundToInt(autoFireShotsJSF.val); SetAutoFireCountButtonLabel(); });
                RegisterAction(fireJSA);
                RegisterAction(clearJSA);
                RegisterAction(resetJSA);

                UpdateAutoFireSliders();

                UIDynamicSlider slider = CreateSlider(maxCumIntensityJSF, true);
                slider.valueFormat = "F0";
                slider.quickButtonsEnabled = false;

                slider = CreateSlider(cumStringGPUIterationsJSF, true);
                slider.valueFormat = "F0";
                slider.quickButtonsEnabled = false;

                slider = CreateSlider(cumStringCollisionDistanceJSF, true);
                slider.valueFormat = "F3";
                slider.quickButtonsEnabled = false;

                slider = CreateSlider(minCumStickinessJSF, true);
                slider.valueFormat = "F0";
                slider.quickButtonsEnabled = false;
                slider = CreateSlider(maxCumStickinessJSF, true);
                slider.valueFormat = "F0";
                slider.quickButtonsEnabled = false;

                CreateToggle(enableCockTwitchJSB, true);

                var spacer = CreateSpacer(true);
                spacer.height = 600f;

                string pluginDetails = pluginDetails = pluginName + " v" + pluginVersion + "\nby " + pluginAuthor + "\nPatron version";

                JSONStorableString text = new JSONStorableString("PluginDetails", pluginDetails);
                var textField = CreateTextField(text, true);
                textField.height = 100f;

                _atomRenameHandle = new SuperController.OnAtomUIDRename(this.AtomNameUpdate);
                SuperController.singleton.onAtomUIDRenameHandlers += _atomRenameHandle;

                _atomRemoveHandle = new SuperController.OnAtomRemoved(this.AtomRemovedUpdate);
                SuperController.singleton.onAtomRemovedHandlers += _atomRemoveHandle;
            }
            else
            {
                JSONStorableString text = new JSONStorableString("Warning", "Plugin must be attached to a male (or Futa) Person atom");
                var textField = CreateTextField(text, false);
                textField.height = 100f;

                string pluginDetails = pluginDetails = pluginName + " v" + pluginVersion + "\nby " + pluginAuthor + "\nPatrons Early Access Release";

                JSONStorableString text2 = new JSONStorableString("PluginDetails", pluginDetails);
                var textField2 = CreateTextField(text2, true);
                textField2.height = 100f;

                DeregisterFloat(minFireIntervalJSF);
                DeregisterFloat(maxFireIntervalJSF);
                DeregisterFloat(maxCumIntensityJSF);
                DeregisterFloat(cumStringGPUIterationsJSF);
                DeregisterFloat(cumStringCollisionDistanceJSF);
                DeregisterBool(enableCockTwitchJSB);
                DeregisterFloat(minCumStickinessJSF);
                DeregisterFloat(maxCumStickinessJSF);
                DeregisterBool(autoFireContinuousJSB);
                DeregisterFloat(autoFireShotsJSF);
            }
        }
        void Update()
        {
            if (isActive)
            {
                FireControl.Update();
                if (FireControl.IsFireControlActive())
                {
                    fireButton.buttonColor = Color.gray;
                    fireButton.textColor = Color.white;
                    fireButton.buttonText.text = "Firing";
                }
                else
                {
                    fireButton.buttonColor = Color.green;
                    fireButton.textColor = Color.black;
                    fireButton.buttonText.text = "Fire";
                }
                OrdnanceDepot.InventoryLevelCheck();
            }

        }

        public void OnEnable()
        {
            try
            {

            }
            catch (Exception e)
            {
                SuperController.LogError($"{nameof(CumAssist)}.{nameof(OnEnable)}: {e}");
            }
        }

        public void OnDisable()
        {
            try
            {

            }
            catch (Exception e)
            {
                SuperController.LogError($"{nameof(CumAssist)}.{nameof(OnDisable)}: {e}");
            }
        }

        public void OnDestroy()
        {
            try
            {
                if (isActive)
                {
                    SuperController.singleton.onAtomUIDRenameHandlers -= _atomRenameHandle;
                    SuperController.singleton.onAtomRemovedHandlers -= _atomRemoveHandle;
                    FireControl.OnDestroy();
                }
            }
            catch (Exception e)
            {
                SuperController.LogError($"{nameof(CumAssist)}.{nameof(OnDestroy)}: {e}");
            }
        }

        private bool isActive = false;
        private SuperController.OnAtomUIDRename _atomRenameHandle;
        private SuperController.OnAtomRemoved _atomRemoveHandle;

        private UIDynamicButton fireButton;
        private UIDynamicButton clearButton;

        public JSONStorableFloat cumStringGPUIterationsJSF;
        public JSONStorableFloat cumStringCollisionDistanceJSF;
        public JSONStorableFloat maxCumIntensityJSF;

        public JSONStorableFloat minCumStickinessJSF;
        public JSONStorableFloat maxCumStickinessJSF;

        public JSONStorableBool enableCockTwitchJSB;
        public bool isMale = false;

        public JSONStorableBool autoFireEnabledJSB;
        public JSONStorableFloat minFireIntervalJSF;
        public JSONStorableFloat maxFireIntervalJSF;

        public JSONStorableBool autoFireContinuousJSB;
        public JSONStorableFloat autoFireShotsJSF;
        public int remainingAutoFireShots;

        private UIDynamicSlider minFireIntervalSlider;
        private UIDynamicSlider maxFireIntervalSlider;
        private UIDynamicToggle autoFireContinuousToggle;
        private UIDynamicSlider autoFireShotsSlider;
        private UIDynamicButton autoFireShotsReset;

    }
}
